define("io.ox/office/editframework/app/editapplication",["io.ox/core/tk/doc-converter-utils","io.ox/core/api/user","io.ox/core/api/tab","io.ox/office/tk/utils","io.ox/office/tk/types","io.ox/office/tk/algorithms","io.ox/office/tk/forms","io.ox/office/tk/utils/io","io.ox/office/tk/utils/logger","io.ox/office/tk/utils/tabutils","io.ox/office/tk/utils/driveutils","io.ox/office/tk/worker/intervalrunner","io.ox/office/tk/dialogs","io.ox/office/baseframework/utils/errorcode","io.ox/office/baseframework/utils/errorcontext","io.ox/office/baseframework/utils/errorcontextdata","io.ox/office/baseframework/utils/clienterror","io.ox/office/baseframework/utils/infostate","io.ox/office/baseframework/utils/errormessages","io.ox/office/baseframework/utils/infomessages","io.ox/office/baseframework/utils/seleniumlogger","io.ox/office/baseframework/app/baseapplication","io.ox/office/baseframework/app/extensionregistry","io.ox/office/rt2/rt2const","io.ox/office/rt2/rt2protocol","io.ox/office/editframework/utils/editconfig","io.ox/office/editframework/utils/operationutils","io.ox/office/editframework/utils/otutils","io.ox/office/editframework/utils/dateutils","io.ox/office/editframework/app/rtconnection","io.ox/office/editframework/app/rtconnectionviewer","io.ox/office/editframework/app/acquireeditrightsworker","io.ox/office/editframework/view/editlabels","gettext!io.ox/office/editframework/main"],function(e,t,n,i,o,r,a,s,l,c,u,d,f,g,p,E,h,O,I,S,m,N,R,D,A,v,y,C,T,w,b,U,F,L){"use strict";function G(e){var t=M(e,"operations",[]);return t.every(_.isObject)?t:(J.error("EditApplication.getOperationsFromData(): invalid elements in operations array",t),[])}function x(e){if(_.isObject(e)&&_.isString(e.action))switch(e.action){case"reload":e.action={itemKey:"document/reload",icon:F.RELOAD_ICON,label:F.RELOAD_LABEL};break;case"acquireedit":e.action={itemKey:"document/acquireeditOrPending",icon:F.EDIT_ICON,label:F.EDIT_LABEL};break;case"loadrestored":e.action={itemKey:"document/reload",icon:F.LOAD_RESTORED_ICON,label:F.LOAD_RESTORED_LABEL};break;default:delete e.action}}function k(e,t,n){var i=H();e.done(function(e){i.resolve(e)}),e.fail(function(e){i.reject(e)});var o=window.setTimeout(function(){i.reject("timeout"),J.warn(n+" - operation timed out")},t);return e.always(function(){window.clearTimeout(o)}),i.promise()}var P=o.isFiniteNumber,B=o.getNumber,M=o.getArray,H=o.newDeferred,q=o.newFulfilled,j=o.newRejected,V=o.toPromise,W=r.stringEndsWith,Y=r.trimAndCleanString,z=r.capitalizeFirst,K=r.filterArray,Q=s.FILTER_MODULE_NAME,Z=s.requireOptModule,J=l.globalLogger,X=l.getFormattedLogBuffer,ee=v.SaveAsType,te=v.STORAGE_AVAILABLE,ne=v.RENAME_DISABLED,ie=v.TRANSFER_EDIT_RIGHTS_TIMEOUT,oe=d.IntervalRunner,re=f.MessageDialog,ae=N.FlushReason,se=C.otLogger,le=C.cleanupRemovedOperations,ce=U.acquireEditLogger,ue=U.AcquireEditRightsWorker,de={ACCEPT:"accept",DECLINE:"decline",INACTIVE:"inactive"},fe=30,ge=-1,pe=L("unnamed"),Ee=8e3,he=2e3,Oe=5e3,_e=["editUserId","editUser","hasErrors","writeProtected","activeUsers","locked","lockedByUser","lockedByUserId","failSafeSaveDone","serverOSN"];return N.extend(function(o,r,s){function l(e){var t={};return _e.forEach(function(n){n in e&&(t[n]=e[n])}),t}function d(e,t){var n=mt.getState();mt.setRootAttribute("data-app-state",n),mt.trigger("docs:state",n,e,t),mt.trigger("docs:state:"+n,t),ce.log("statechange",n,e)}function f(e){var t=on?"error":Sn?"preview":Yt?tn||!Kt?"readonly":rt()?"sending":Qt?"ready":"initial":"offline";if(Vt!==t){var n=Vt;Vt=t,d(n,e)}}function C(e){Kt!==e&&(Kt=e,mt.trigger("docs:editmode",Kt),ce.log("$back(LightPink)changeEditMode",Kt),mt.trigger(Kt?"docs:editmode:enter":"docs:editmode:leave"),f())}function U(e,t){if("load"===e.action&&_.isObject(e.file)){var n=e.file.id+"_"+e.file.folder_id,i=n+"_OSN",o=n+"_FILEVERSION",r=n+"_STORAGEVERSION",a=localStorage.getItem(i),s=localStorage.getItem(o);localStorage.getItem(r)>=un&&a&&s&&(a=parseInt(a,10),s=parseInt(s,10),_.isNumber(a)&&_.isNumber(s)&&(t.storageOSN=a,t.storageVersion=s))}}function F(){return{documentFileLockedByUser:nn,fullFileName:mt.getFullFileName(),oldEditUser:zt,isEditor:Ye()}}function H(e,t){var n=L("Read-Only Mode"),i=null,o=null,r=null;_.isString(e)?(o={type:"info",message:e,headline:n},isNaN(t)||(o.duration=t),o=_.extend({},o,{action:"acquireedit"})):(r=F(),i=mt.getErrorState(),o=jn,_.isObject(o)||(_.isObject(i)&&(i.isError()||i.isWarning())?o=I.getMessageData(i,r):(i=mt.getInfoState(),_.isString(i)&&(o=S.getMessageData(i,r))))),mt.extendMessageData(o),Rt.yell(o)}function Ie(e){var t=_.findWhere(On,{clientUID:e});return t&&t.userName||""}function Se(){function e(){Pn=!0}mt.getUserSettingsValue("showToolbars",!0)?Rt.getToolBarTabs().one("tab:activated",e):mt.waitForImportSuccess(e)}function me(e){var t=g.isErrorCode(e)?e:Ne(e);if(t.setErrorContext(p.CONNECTION),lt()){var n=Ct.hasPendingActions()||mt.hasUnsavedChangesOffice();tn=!0,C(!1),n?Ht?mt.setInternalError(h.ERROR_SYNCHRONIZATION_NOT_POSSIBLE_LOCAL_CHANGES,p.CONNECTION):mt.restoreDocument(t):(r.action="load",delete r.template,mt.reloadDocument())}else mt.setInternalError(t,p.CONNECTION)}function Ne(e){var t;switch(e){case"reset":t=new g(h.ERROR_CONNECTION_RESET_RECEIVED);break;case"timeout":t=new g(h.ERROR_CONNECTION_TIMEOUT);break;case"notMember":t=new g(h.ERROR_CONNECTION_NOT_MEMBER);break;default:t=new g(h.ERROR_UNKNOWN_REALTIME_FAILURE)}return t}function Re(){an=!0,Yt&&!on&&!mt.isInQuit()&&lt()&&(rn=Kt,Yt=!1,Ht&&Qn.abort(),Dn?Ct.hasPendingActions()?mt.setInternalError(h.ERROR_OFFLINE_WHILE_SYNC_LOCAL_CHANGES,p.OFFLINE):mt.setInternalError(h.ERROR_OFFLINE_WHILE_SYNCHRONIZING,p.OFFLINE):(tn=!0,C(!1),f(),mt.setInternalError(h.WARNING_READONLY_DUE_TO_OFFLINE,p.OFFLINE)),w.log("Connection offline handler called by Realtime!"),ke())}function De(){!an||Yt||on||mt.isInQuit()||(w.log("Connection online handler called by Realtime!"),Ht&&Qn.start(),Yt=!0,Rn&&(Ht?Ae():ve()),f(),H())}function Ae(){w.log("Client supports synchronization - starting to sync with server"),_.isObject(mt)&&(rn?(mt.setInternalError(h.WARNING_SYNC_AFTER_OFFLINE,p.SYNCHRONIZATION),w.log("Client is editor - synchronizing with server using current client state"),Dn="editSync",Tt&&Tt.length>0&&li()):(mt.setInternalError(h.WARNING_SYNC_FOR_VIEWER,p.SYNCHRONIZATION),w.log("Client is viewer - waiting for server messages to unlock view"),Dn="viewSync"),mt.executeDelayed(function(){!An&&Dn&&(w.log("Synchronization time out detected - no synchronization possible"),je({cause:"timeout"}))},"EditApplication.startSynchronizationProcessOT",1e3*fe),Dn&&lt()&&(Ct.sync(),Ct.syncStable().then(function(e){w.log("SyncStable response received ",e),je(e&&e.docStatus?null:{cause:"reset"})},function(){je({cause:"reset"})}).done(function(){mt.repeatDelayed(function(){return!Dn||An?i.BREAK:lt()?void je(null):(je({cause:"reset"}),i.BREAK)},"EditApplication.startSynchronizationProcessOT",{delay:0,repeatDelay:1e3*fe/10,cycles:9})})))}function ve(){if(w.log("Client supports synchronization - starting to sync with server"),_.isObject(mt)&&(rn?(mt.setInternalError(h.WARNING_SYNC_AFTER_OFFLINE,p.SYNCHRONIZATION),w.log("Client is editor - synchronizing with server using current client state"),Dn="editSync",Tt&&Tt.length>0&&li()):(mt.setInternalError(h.WARNING_SYNC_FOR_VIEWER,p.SYNCHRONIZATION),w.log("Client is viewer - waiting for server messages to unlock view"),Dn="viewSync"),mt.executeDelayed(function(){!An&&Dn&&(w.log("Synchronization time out detected - no synchronization possible"),$e(null,null,null,{cause:"timeout"}))},"EditApplication.startSynchronizationProcess",1e3*fe),Dn&&lt())){var e=-1,t=null,n=Ct.sync().then(function(n){if(w.log("Sync response received ",n),n&&n.docStatus){var o=Nt.getOperationStateNumber();return t=i.getStringOption(n.docStatus,"editUserId",""),e=i.getIntegerOption(n.docStatus,"serverOSN",-1),sn=t,$e(t,o,e,null),$.when()}throw new Error("sync response contains no mandatory data - synchronization impossible!")},function(){$e(null,null,null,{cause:"reset"})});(n=n.then(function(){if(Dn&&lt()){var n=Ct.syncStable();return n.done(function(n){if(w.log("SyncStable response received ",n),n&&n.docStatus){var o=Nt.getOperationStateNumber();t=i.getStringOption(n.docStatus,"editUserId",""),sn=t,$e(t,o,e,null)}else $e(null,null,null,{cause:"reset"})}),n.fail(function(){$e(null,null,null,{cause:"reset"})}),n}throw $e(null,null,null,{cause:"reset"}),new Error("synchronization not possible")},function(){$e(null,null,null,{cause:"reset"})})).done(function(){mt.repeatDelayed(function(){if(!Dn||!lt())return $e(null,null,null,{cause:"reset"}),i.BREAK;var n=Nt.getOperationStateNumber();$e(_.isString(t)?t:sn,n,e,null)},"EditApplication.startSynchronizationProcess",{delay:0,repeatDelay:1e3*fe/10,cycles:9})})}}function ye(e,t){var n;w.log("Error handler called by RT2 communication layer, cause = "+JSON.stringify(e)),t&&"pending"===t.state()&&t.reject(e),_.isObject(e)&&_.isString(e.error)&&(n=new g(e)),mt&&("GENERAL_SESSION_INVALID_ERROR"===n.getCodeAsConstant()?Ce(n):"GENERAL_DOCUMENT_ALREADY_DISPOSED_ERROR"===n.getCodeAsConstant()?_.isString(Dn)?(An=!0,Ht?je({cause:"error:disposed"}):$e(null,null,null,{cause:"error:disposed"})):mt.setInternalError(n,p.CONNECTION):"TOO_MANY_CONNECTIONS_ERROR"===n.getCodeAsConstant()?(An=!0,Dn=null,mt.setInternalError(n,p.CONNECTION)):mt.isLocked()||mt.isInQuit()||_.isString(Dn)?_.isString(Dn)&&(An=!0,Ht?je({cause:"reset"}):$e(null,null,null,{cause:"reset"})):"HANGUP_INVALID_OPERATIONS_SENT_ERROR"===e.error||"HANGUP_INVALID_OSN_DETECTED_ERROR"===e.error?mt.setInternalError(e,p.CONNECTION):"HANGUP_NO_EDIT_RIGHTS_ERROR"===e.error?mt.restoreDocument(n):(n=h.ERROR_UNKNOWN_REALTIME_FAILURE,mt.setInternalError(e,p.CONNECTION)))}function Ce(e){function t(){ox.off("relogin:success",t),ox.off("relogin:fail",n),i=!1,Ht?Ae():ve(),Vn=!1}function n(){ox.off("relogin:success",t),ox.off("relogin:fail",n),mt.setInternalError(e),Vn=!1}if(!Vn){Vn=!0;var i=!0;mt.setInternalError(h.WARNING_SESSION_INVALID_DETECTED,p.CONNECTION),tn=!0,C(!1),f(),ox.on("relogin:success",t),ox.on("relogin:fail",n),mt.executeDelayed(function(){i&&(i=!1,ox.trigger("relogin:required"))},"EditApplication.connectionErrorHandler",5e3)}}function Te(){w.log("NoResponseInTime notification received - Server has not responded in a certain time"),mt.isLocked()||mt.isInQuit()||mt.setInternalError(h.WARNING_CONNECTION_INSTABLE)}function we(){if(w.log("Shutdown notification received - Document middleware node is going down!"),!mt.isLocked()&&!mt.isInQuit()&&lt()){var e=Ct.hasPendingActions()||mt.hasUnsavedChanges(),t={silentShutdownConfig:{skipCloseDoc:!0,skipDisconnect:!0}};Kt&&e?mt.setInternalError(h.ERROR_SERVER_SHUTDOWN_NO_RESCUE_POSSIBLE,p.CONNECTION,null,t):mt.setInternalError(h.ERROR_SERVER_GOING_TO_SHUTDOWN,p.CONNECTION,null,t)}}function be(){if(w.log("Crashed node notification received - Document middleware node is not available anymore!"),!mt.isLocked()&&!mt.isInQuit()&&lt()){var e=Ct.hasPendingActions()||mt.hasUnsavedChanges(),t={silentShutdownConfig:{skipCloseDoc:!0,skipDisconnect:!0}};Kt&&e?mt.setInternalError(h.ERROR_SERVER_NODE_UNAVAILABLE_NO_RESCUE_POSSIBLE,p.CONNECTION,null,t):mt.setInternalError(h.ERROR_SERVER_NODE_UNAVAILABLE,p.CONNECTION,null,t)}}function Ue(e,t){if(w.log("Hangup notification received - document cannot be edited anymore!"),!mt.isLocked()&&!mt.isInQuit()&&lt()){var n=Ct.hasPendingActions()||mt.hasUnsavedChanges(),i=new g(t);i.isError()||(i=new g(h.ERROR_SERVER_NOTIFIED_A_CRITICAL_DOC_PROBLEM)),Ye()&&(n||Fe(i))?Ht?mt.setInternalError(h.ERROR_SYNCHRONIZATION_NOT_POSSIBLE_LOCAL_CHANGES,p.CONNECTION):mt.restoreDocument(i):mt.setInternalError(i,p.CONNECTION)}}function Fe(e){var t=!1;if(g.isErrorCode(e)&&e.isError())switch(e.getCodeAsConstant()){case"SAVEDOCUMENT_FILE_HAS_CHANGED_ERROR":case"GENERAL_FILE_NOT_FOUND_ERROR":case"GENERAL_PERMISSION_READ_MISSING_ERROR":case"GENERAL_PERMISSION_WRITE_MISSING_ERROR":case"LOADDOCUMENT_CANNOT_RETRIEVE_OPERATIONS_ERROR":t=!0}return t}function Le(e,t){if(!mt.isInQuit())if(new g(t).isError())Ln&&Ln.reject(t);else{var n=i.getStringOption(t,"fileId",null),o=i.getStringOption(t,"fileName",null);n&&o?(Ln&&Ln.resolve(t),mt.updateFileDescriptor({id:n,filename:o,title:u.getFileBaseName(o)}),r.action="load",delete r.template,Qt=!1,mt.reloadDocument()):Ln&&Ln.reject(t)}}function Ge(e){mt.hasUnsavedChangesOffice()?mt.executeDelayed(function(){Ge(e)},"EditApplication.checkForPendingOperations",2e3):li().then(function(){lt()&&Ct.canLoseEditRights(e),ln=!1,mt.getController().update(),w.log("sent canLoseEditRights")})}function xe(e){if(ce.log("$back(lightgreen)handleEditRequestViaUpdate",e),!mt.isInQuit()&&null===Dn&&sn===At){var t=e&&_.isArray(e.activeUsers)?_.find(e.activeUsers,function(e){return e&&e.clientUID!==At&&e.requestsEditRights}):null,n=t?t.clientUID:null;if(n){if(ce.log("$back(lightgreen)__handleEditRequestViaUpdate - clientUIDRequesting ",Mn,Ie(n)),Mn)return ce.log("$back(lightgreen)__handleEditRequestViaUpdate - BLOCK OTHER REQUESTS?",n),void(Mn.clientUID!==n&&lt()&&(ce.log("$back(lightgreen)__handleEditRequestViaUpdate - REQUEST BLOCKED!"),Ct.declineEditRights(n)));ce.log("$back(lightgreen)__handleEditRequestViaUpdate - Request edit rights",Ft);var i=Me(n);i.done(function(e){if(ce.log("$back(lightgreen)__handleEditRequestViaUpdate - answer: "+e),e===de.DECLINE)return ce.log("$back(lightgreen)__handleEditRequestViaUpdate - EditRights transfer declined"),void(lt()&&Ct.declineEditRights(n));ce.log("$back(lightgreen)__handleEditRequestViaUpdate - EditRights transfer accepted"),ln=!0,C(!1),mt.setCurrentInfoState(O.INFO_PREPARE_LOSING_EDIT_RIGHTS,{showMessage:e===de.INACTIVE}),f(),mt.getController().update();var t=s&&s.prepareLoseEditRightsHandler;(t?V(t.bind(mt)):q()).always(function(){w.log("handle PrepareLosingEditRights"),mt.executeDelayed(function(){Ge(n)},"EditApplication.handlePrepareLosingEditRights",1e3)})}),i.fail(function(e){ce.log("$back(lightgreen)__handleEditRequestViaUpdate - EditRights transfer failure, reason:",e)})}}}function ke(){Bn.abort(),ce.log("$back(SandyBrown)abortPendingEditRightsRequest")}function Pe(){Mn&&(Mn.promise.abort(),ce.log("abortPendingEditRightsTransfer"))}function Be(){var e=Ft>0,t=null,n=_.now()-Hn;return ce.log("inactivCheck knownWhenLastOpWasSend",e),e?(t=Date.now()-Ft,ce.log("inactivCheck sendActionsTime",Ft,t)):(t=Date.now()-mn,ce.log("inactivCheck importFinishedTime",mn,t)),ce.log("inactivCheck User is inactive?",t>12e4,!i.wasKeyPressedWithinTime(12e4),"timeDeltaToLastTransfer",n,n>12e4),t>12e4&&!i.wasKeyPressedWithinTime(12e4)&&n>12e4}function Me(e){if(ce.log("$back(MediumAquaMarine)handleEditRightsTransferRequest"),Be())return q(de.INACTIVE);var t=mt.newDeferred("EditApplication.handleEditRightsTransferRequest"),n=mt.createAbortablePromise(t);Mn={deferred:t,promise:n,clientUID:e},ce.log("$back(MediumAquaMarine)__handleEditRightsTransferRequest - callForUserInput"),Rt.yell({type:"question",message:L("%1$s is asking for edit rights. This request will be accepted automatically in %2$d seconds.",_.noI18n(Ie(e)),Math.floor(ie/1e3)),duration:ie,progress:!0,disableCloser:!0,restoreHidden:!0,priority:!0,renderFn:function(e){var n=$.button({label:L("Decline")}).addClass("btn-default").css({marginRight:5});n.on("click tab",function(){ce.log("$back(Orchid)__handleEditRightsTransferRequest - DECLINE BUTTON PRESSED BY USER"),Hn=Date.now(),ce.log("$back(MediumAquaMarine)__handleEditRightsTransferRequest -> DECISION: declined"),t.resolve(de.DECLINE)});var i=$.button({label:L("Accept")}).addClass("btn-primary");i.on("click tab",function(){ce.log("$back(Orchid)__handleEditRightsTransferRequest - ACCEPT BUTTON PRESSED BY USER"),ce.log("$back(MediumAquaMarine)__handleEditRightsTransferRequest -> DECISION: accepted"),t.resolve(de.ACCEPT)});var o=$('<div class="button-area" style="text-align:center;margin-top:10px;">');e.append(o.append(n,i))}});var i=mt.executeDelayed(function(){ce.log("$back(MediumAquaMarine)__handleEditRightsTransferRequest - DECISION: accepted automatically"),t.resolve(de.ACCEPT)},"EditApplication.handleEditRightsTransferRequest.autoAcceptTimer",{delay:ie,background:!0});return n.always(function(){Mn=null,i.abort(),Rt&&Rt.hideYell({priority:!0})}),n}function He(e){ce.log("$back(lightblue)applyEditState - DOC UPDATE",e);var t=Ht?null:i.getStringOption(e,"editUserId",""),n=Ht?null:Ie(t),o=Ht?null:n||e.editUser,r=Ht?null:Kt,a=Ht?null:r,s=mt.getFileDescriptor(),l=Nt.getOperationStateNumber(),c=Ht?null:i.getIntegerOption(e,"serverOSN",-1),d=new g(e),E=i.getIntegerOption(e,"lockedByUserId",ge),I=i.getBooleanOption(e,"writeProtected",null),S=i.getBooleanOption(e,"rescueDoc",null);if(Ht?w.log("applyEditState: clientOSN = "+l):w.log("applyEditState: clientOSN = "+l+", localServerOSN = "+c),!on&&_e.some(function(t){return t in e})){if(Ht||t===sn||(w.log("Edit rights changed, new editing user id: "+t),a=At===t,mt.setCurrentInfoState(O.INFO_USER_IS_CURRENTLY_EDIT_DOC,{showMessage:!1}),ce.log("$back(lightblue)__applyEditState - EDITOR HAS BEEN CHANGED","|editClientId:",t,"|oldEditClientId:",sn),Bn.running&&""!==t&&(ce.log("$back(lightblue)__applyEditState - FORCE TIMER ABORTED the editor has been changed"),ke())),i.getBooleanOption(e,"failSafeSaveDone",!1)&&u.propagateChangeFile(s),i.getBooleanOption(e,"hasErrors",!1))return mt.setInternalError(h.ERROR_GENERAL_SYNCHRONIZATION_ERROR,p.SYNCHRONIZATION),void w.error("synchronization to the server has been lost.");tn||(v.RESCUE_DOCUMENT_READONLY&&_.isBoolean(S)&&S?(tn=!0,C(!1),mt.setInternalError(h.WARNING_RESCUE_DOC_CANNOT_BE_CHANGED,p.READONLY)):_.isBoolean(I)&&I?(tn=!0,C(!1),mt.setInternalError(h.WARNING_NO_PERMISSION_FOR_DOC,p.READONLY)):E!==ge&&ox.user_id!==E&&(tn=!0,C(!1),mt.setInternalError(h.WARNING_DOC_IS_LOCKED,p.READONLY),nn=i.getStringOption(e,"lockedByUser",""))),tn||ln||(Ht?C(!0):(w.log("Edit mode: "+a),C(a),!a&&(!Yt||r||o!==zt&&o.length)&&(zt=o,mt.setCurrentInfoState(O.INFO_USER_IS_CURRENTLY_EDIT_DOC)),Yt&&t&&t!==sn&&(qe(t),zt=o),a&&!1===r&&mt.setCurrentInfoState(O.INFO_EDITRIGHTS_RECEIVED),Yt&&!a&&r&&-1!==c&&l>c&&(mt.setInternalError(h.ERROR_GENERAL_SYNCHRONIZATION_ERROR,p.SYNCHRONIZATION),w.error("synchronization between client and server is broken. Switching editor into read-only mode. New edit mode: "+a+"Old edit mode: "+r+", local Server OSN: "+c+", Client OSN: "+l))),(d.isError()||d.isWarning())&&mt.setInternalError(d,p.GENERAL)),Yt=!0,f()}}function qe(e){var t=sn,n=e,i=[n];_.isString(t)&&t.length>0&&i.push(t),sn=n,ai(i)}function je(e){function t(){w.log("logSynchronizationState... ","\n     localChanges = ",i,"\n     rtConnection.getPendingActions() = ",lt()&&JSON.stringify(Ct.getPendingActions()),"\n     self.getPendingActions() = ",JSON.stringify(mt.getPendingActions()),"\n     mustSyncNowMode = ",Dn,"\n     failedData = ",JSON.stringify(e))}var n=null,i=function(){var e=mt.getPendingActions(),t=lt()&&Ct.getPendingActions();return _.isArray(e)&&e.length>0||_.isObject(t)&&_.isArray(t.actions)&&t.actions.length>0}();if(Dn){if(w.log("Checking synchronization state with server"),e){switch(e.cause){case"timeout":w.log("Synchronization not possible - maybe connection instance is gone"),(n=new g(h.ERROR_SYNCHRONIZATION_TIMEOUT)).setErrorContext(p.SYNCHRONIZATION),t(),Dn=null;break;case"notMember":case"reset":case"error:disposed":w.log("Synchronization not possible - connection instance is gone or rt-state broken"),(n=new g(h.ERROR_SYNCHRONIZATION_NOT_POSSIBLE)).setErrorContext(p.SYNCHRONIZATION),t(),Dn=null}me(n)}switch(Dn){case"editSync":if(i)return;w.log("Synchronization successfully completed"),tn=!1,C(!0),mt.setCurrentInfoState(O.INFO_SYNCHRONIZATION_SUCCESSFUL,{resetWarning:!0});break;case"viewSync":w.log("Synchronization for viewer completed"),mt.setCurrentInfoState(O.INFO_SYNCHRONIZATION_RO_SUCCESSFUL,{resetWarning:!0})}t(),Dn=null}}function $e(e,t,n,i){function o(e,t){w.log("logSynchronizationState... ","\n     localChanges = ",a,"\n     rtConnection.getPendingActions() = ",lt()&&JSON.stringify(Ct.getPendingActions()),"\n     self.getPendingActions() = ",JSON.stringify(mt.getPendingActions()),"\n     mustSyncNowMode = ",Dn,"\n     clientOSN = ",e,"\n     serverOSN = ",t,"\n     oldEditUser = ",zt,"\n     failedData = ",JSON.stringify(i))}var r=null,a=function(){var e=mt.getPendingActions(),t=lt()&&Ct.getPendingActions();return _.isArray(e)&&e.length>0||_.isObject(t)&&_.isArray(t.actions)&&t.actions.length>0}();if(Dn){if(w.log("Checking synchronization state with server"),i){switch(i.cause){case"timeout":w.log("Synchronization not possible - maybe connection instance is gone"),(r=new g(h.ERROR_SYNCHRONIZATION_TIMEOUT)).setErrorContext(p.SYNCHRONIZATION),o(t,n),Dn=null;break;case"notMember":case"reset":case"error:disposed":w.log("Synchronization not possible - connection instance is gone or rt-state broken"),(r=new g(h.ERROR_SYNCHRONIZATION_NOT_POSSIBLE)).setErrorContext(p.SYNCHRONIZATION),o(t,n),Dn=null}me(r)}switch(Dn){case"editSync":if(Ye()){if(a)return;w.log("Synchronization successfully completed"),tn=!1,C(!0),mt.setCurrentInfoState(O.INFO_SYNCHRONIZATION_SUCCESSFUL,{resetWarning:!0})}else a?(w.log("Synchronization not possible - editor changed"),(r=new g(h.ERROR_SYNCHRONIZATION_LOST_EDIT_RIGHTS)).setErrorContext(p.SYNCHRONIZATION),mt.restoreDocument(r)):t>=n?(w.log("Synchronization possible - but we lost edit rights"),tn=!1,mt.setCurrentInfoState(O.INFO_SYNCHRONIZATION_RO_SUCCESSFUL,{resetWarning:!0})):(w.log("Synchronization not possible - did not receive missing operations"),mt.reloadDocument());break;case"viewSync":t>=n?(w.log("Synchronization for viewer completed"),tn=!1,mt.setCurrentInfoState(O.INFO_SYNCHRONIZATION_RO_SUCCESSFUL,{resetWarning:!0})):(w.log("Synchronization not possible - did not receive missing operations"),mt.reloadDocument())}o(t,n),Dn=null}}function Ve(e){var t=mt.getFileDescriptor(),n=i.getStringOption(e,"fileName",""),o=i.getStringOption(e,"com.openexchange.file.sanitizedFilename",""),r=i.getStringOption(e,"fileVersion",""),a={};n.length>0&&n!==i.getStringOption(t,"filename")&&(a.filename=n),o.length>0&&o!==i.getStringOption(t,"com.openexchange.file.sanitizedFilename")&&(a["com.openexchange.file.sanitizedFilename"]=o),r.length>0&&r!==i.getStringOption(t,"version")&&(a.version=r),on||_.isEmpty(a)||(mt.updateFileDescriptor(a),mt.getController().update(),f())}function We(e,t){var n=null,i=null;return e.length===t.length&&(n=_.copy(e,!0),i=_.copy(t,!0),_.each(n,function(e){e.userData&&e.userData.selections&&delete e.userData.selections,e.userData&&e.userData.ranges&&delete e.userData.ranges}),_.each(i,function(e){e.userData&&e.userData.selections&&delete e.userData.selections,e.userData&&e.userData.ranges&&delete e.userData.ranges}),_.isEqual(n,i))}function Ye(){return Ht||At===sn}function ze(e){Ze(e,!0).done(function(){Xn.shift(),Xn.length>0&&ze(Xn[0])})}function Ke(){Ht&&Xn.length>0&&!Nt.isProcessingActions()&&ze(Xn[0])}function Qe(e,t){var n;e>Kn?t?e===Kn+1?(Kn=e,Zn=-1):(Zn=e,se.info("DEBUGGING: Saving OSN from ack temporarily: "+Zn)):(e>Kn+1&&se.info("Setting server OSN. Info: Increasing OSN by more than 1. Increasing from: "+Kn+" to "+e),n=Kn,Zn===(Kn=e)+1?(se.info("Updating server OSN with saved ack osn: "+Zn+". Triggering event: docs:ackosn:updated."),Kn=Zn,Zn=-1,mt.trigger("docs:ackosn:updated")):Zn>=0&&Kn>Zn&&(se.error("ERROR: Setting server OSN. Receiving OSN from external operation: "+e+". But still have temporary OSN from acknowledge: "+Zn),se.error("ERROR: Current locally used server OSN is: "+n),Zn=-1,mt.trigger("docs:ackosn:updated"))):se.info("Setting server OSN. Avoiding to set server OSN to: "+e+". Current OSN is already: "+Kn),se.info("Setting server OSN to: "+Kn),Nt.trigger("change:osn",Kn)}function Ze(e,t){if(on)return w.error("EditApplication.applyRemoteOperations(): failed due to internal error"),$.Deferred().reject();var n=Ht?B(e.docStatus,"serverOSN",-1):0;if(n<0)return J.error("EditApplication.applyRemoteActions(): missing server OSN in external operations"),$.Deferred().reject();var i=G(e);if(0===i.length)return Ht&&Qe(n),$.when();if(y.handleMinifiedActions([{operations:i}],!0),Ht||Nt.getUndoManager().clearUndoActions(),w.log("EditApplication.applyRemoteOperations(): last remote operation: "+JSON.stringify(_.last(i))),Ht){if(Nt.isProcessingInternalOperations()||Xn.length>0&&!t)return t||Xn.push(e),mt.createResolvedPromise({cached:!0});if(se.info("received external operations with server OSN "+n),Qe(n),zn.length>0){Jn+=i.length,se.info("DEBUGGING: external operations before:",i),se.info("DEBUGGING: local operations without ACK before:",zn);try{i=mt.getOTManager().transformOperations(i,zn)}catch(e){return se.exception(e,"operation transformation failed"),$.Deferred().reject({cause:"operation"})}se.info("DEBUGGING: external operations after:",i),se.info("DEBUGGING: local operations without ACK after:",zn)}else se.info("DEBUGGING: external operations not transformed:",i)}var o=Nt.applyExternalOperations(i);return o.done(function(){Zt=!0}),o.fail(function(){mt&&!mt.isInQuit()&&w.error("EditApplication.applyRemoteOperations(): failed")}),o}function Je(e){if(Ht)return!1;var t=!1,n=Nt.getOperationStateNumber();return v.RESTORE_DOCUMENT_ENABLED&&e.length>0&&(t=!("editSync"!==Dn||!lt()||!Ct.hasPendingActions())||n!==e[0].osn),t}function Xe(e){if(!_.isObject(e))return J.error("EditApplication.registerUpdateMessageData(): invalid response (object expected):",e),this.setInternalError(h.ERROR_WHILE_MODIFYING_DOCUMENT,p.GENERAL),$.Deferred().reject();if(w.log("EditApplication.registerUpdateMessageData(): received update message:",e),In.length>0&&At!==e.editUserId){w.log(" "+In.length+' existing pending updates must be changed to user "'+e.editUserId+'"');var t={editUser:e.editUser,editUserId:e.editUserId};In.forEach(function(e){_.extend(e,t)})}In.push(e);var n=si(e);return n.always(function(){In.shift(),w.log("EditApplication.registerUpdateMessageData(): update processed, "+In.length+" pending messages left")}),n}function et(e,t,n){if(!e)return q();var i=V(e.bind(mt)).fail(function(){J.warn("EditApplication - failed initialization step: "+n)});return i=i.then(function(e){return mt.isInQuit()?j({cause:"closing"}):e}),mt.launchTracker.asyncStep(i,t,"EditApp: "+n)}function tt(){var e=mt.createDeferred("EditApplication.establishConnection");return et(function(){var t=lt()?Ct.connect():mt.createRejectedPromise();return w.log("Channel UID:",lt()?Ct.getChannelUID():null),ti=lt()?Ct.getDocUID():"null",ni=lt()?Ct.getClientUID():"null",t=t.then(function(e){var t=new g(e);if(e.hasErrors||t.isError())throw e;return e}),(t=t.then(function(e){var t=new g(e);if(t.isWarning()&&"ADVISORY_LOCK_SET_WARNING"===t.getCodeAsConstant()){var n=JSON.parse(t.getErrorValue()),i=new Date(n.since),o=T.format(i,T.getDateFormat())+" "+T.format(i,T.getTimeFormat()),r=L("Document in use"),a=mt.getUserInfo(n.uid).then(function(e){var t=L("%1$s edits this document since %2$s on %3$s. To avoid data loss, please open the document on %3$s. Do you want to cancel opening it here?",L.noI18n(e.displayName),L.noI18n(o),L.noI18n(n.hostName));return Rt.showQueryDialog(r,t)},function(){var e=L("Another user edits this document since %1$s on %2$s. To avoid data loss, please open the document on %3$s. Do you want to cancel opening it here?",L.noI18n(o),L.noI18n(n.hostName));return Rt.showQueryDialog(r,e)});return a=a.then(function(){return mt.quit(),e},function(t){if("close"===t)throw t;return e=_.extend({advisoryLock:"reset"},e)})}return e})).done(function(t){e.resolve(t)}),t.fail(function(t){e.reject(t)}),e.promise()},"connect","Realtime connection established")}function nt(e){if(_.isObject(mt)&&!mt.isInQuit()||(e={cause:"quit"}),vn)return{cause:""};var t=new g(e),n=t.getCodeAsConstant();switch(on=!0,Pt.call(mt,e),e=_.clone(e),n){case"GENERAL_FILE_NOT_FOUND_ERROR":en=!0}return t.isError()||(t=function(e){return e&&e.error_desc&&e.error_id&&_.isString(e.error_desc)&&_.isString(e.error_id)}(e)?function(e){if(t=new g(g.GENERAL_ERROR),e&&e.error_desc){var n=e.error_desc;t.setDescription(n)}return t}(e):new g(h.ERROR_UNKNOWN_REALTIME_FAILURE)),mt.isInQuit()||mt.setInternalError(t,p.LOAD,null,{showMessage:!1}),e=_.extend({},e,{errorForErrorCode:mt.isViewerMode()}),vn=!0,e}function it(e){return{operations:e||[]}}function ot(){return wt&&wt.operations&&wt.operations.length>0}function rt(){return bt||Tt.length>0||ot()}function at(e){K(zn,function(t){return!t[e]})}function st(e){var t=Rt.processUnsavedComment(e===ae.QUIT);return t=t.then(function(){return Jt}),t=t.then(function(){var t=s&&s.prepareFlushHandler;return t?t.call(mt,e):null}),t=t.then(function(){var t=li();return e===ae.QUIT&&(t=k(t,Oe,"EditApplication.prepareFlushDocument")),t})}function lt(){return!(!Ct||Ct.destroyed)}function ct(){Ct&&(ke(),Pe(),Ct.destroy(),mt.rtConnection=Ct=null)}function ut(e,t,n){if(ii||!lt())return j();var i=null,o=Ct.getConnectOpenState();if(w.log("EditApplication.executeShutdownStep: - silentShutdownEntered:",dt()," connectionOpenState:",o," action:",e),!dt()){var r=!1,a=!1,s=!1;switch(o){case"unknown":case"joining":r=!1,a=!1,s=!1;break;case"joined":r=!1,a=!1,s=!0;break;case"opening":r=!0,a=!1,s=!0;break;case"opened":r=!1,a=!0,s=!0}i=function(){switch(e){case".abortOpen":return r?Ct.abortOpen():null;case".closeDocument":return a?Ct.closeDocument(t):null;case".disconnect":return s?Ct.disconnect(t):null}}()}return dt()&&(i=function(){switch(e){case".closeDocument:force":return Ct.closeDocument(t);case".disconnect:force":return Ct.disconnect(t)}}()),i?n?k(i,n,'EditApplication.executeShutdownStep("'+e+'")'):i:j()}function dt(){return!(null===$n)}function ft(e){var t=i.getBooleanOption(e,"skipCloseDoc",!1),n=i.getBooleanOption(e,"skipDisconnect",!1);if(w.log("EditApplication.silentShutdownConnection entered! - silentShutdownConfig:",e,"silentShutdownConnectionEntered",dt()),!dt()){tn=!0,C(!1),Ht&&Qn.abort();var o=$.Deferred();$n=o.promise(),lt()&&Ct.off();var r;(r=t?$.when():ut(".closeDocument:force",{no_restore:qn},500)).always(function(e){var i;if(n)i=$.when();else{var a="timeout"===e,s="rejected"===r.state(),l=a||Boolean(t)||s;w.log("EditApplication.silentShutdownConnection - closeDocument rejected by timeout?:",a),i=ut(".disconnect:force",l,500)}i.always(function(){ct(),w.log("EditApplication.silentShutdownConnection is finished"),o.resolve()})})}}function gt(e){function t(e){d&&Rt.updateBusyProgress(e)}function n(e){function t(){return _.pluck(Nt.getSupportedStorageExtensions({allApps:!0}),"extension").concat(g)}var n=localStorage.getItem("appsuiteDocsExpiryDates"),i=_.now();n&&(n=JSON.parse(n),_.isObject(n)?_.each(n,function(o,r){if(r!==e&&i>o){var a=a||t();_.each(a,function(e){var t=r+e;localStorage.removeItem(t)}),delete n[r]}}):n=null),(n=n||{})[e]=i+6048e5,localStorage.setItem("appsuiteDocsExpiryDates",JSON.stringify(n))}function o(){return u.propagateChangeFile(l)}var a=null,s=mt.getWindow(),l=mt.getFileDescriptor(),d=!1,f=null,g=["_OSN","_FILEVERSION","_STORAGEVERSION","_OPERATIONS"],p="logout"===e,E=mt.launchTracker;s&&s.busy();var h=Qt||Xt||Zt||en,O="new"===r.action||r.template;l&&(h||v.LOG_PERFORMANCE_DATA||!O&&On.length<=1)&&(f={file:_.extend({last_opened:Date.now()},l),app:mt.appType},E.setItem("LocalStorage",pn),E.setItem("FastEmptyLoad",Nn),E.sendData());var I=lt()&&Ct.isConnected()&&!mt.isShutdownReceived();return l&&I?(f=qn?f:_.extend({no_restore:qn},f),a=c.BROWSER_TAB_SUPPORT?pt(e,f).progress(t):pt(e,f).then(function(e){function t(t){var n=i.getBooleanOption(t,"migration",!1);_.each(g,function(e){localStorage.removeItem(r+e)}),n&&(P(e.syncInfo.fileVersion)?_.each(_.range(e.syncInfo.fileVersion>O?e.syncInfo.fileVersion-O:0,e.syncInfo.fileVersion),function(e){_.each(g,function(t){localStorage.removeItem(r+"_"+e+t)})}):(localStorage.removeItem(r+"_"+e.syncInfo.fileVersion),localStorage.removeItem(r+"_CURRENTVERSION")))}var o=null,r=null,a=null,s=null,l=null,c=null,u=null,f=Qt||Xt||Zt,E=Nt.getOperationStateNumber(),h=0,O=20;return oi(),(f||!pn)&&e&&e.syncInfo&&!p&&!mt.isDocumentEncrypted()&&te&&cn&&gn&&_.isFunction(Nt.getFullModelDescription)&&e.syncInfo.fileVersion&&e.syncInfo.fileId&&e.syncInfo.folderId&&P(e.syncInfo["document-osn"])&&E===e.syncInfo["document-osn"]&&(n(r=e.syncInfo.fileId+"_"+e.syncInfo.folderId),u=mt.newDeferred("EditApplication.saveLocalStorage"),mt.executeDelayed(function(){d=!0},"EditApplication.saveFileInStorage",1500),mt.executeDelayed(function(){u.notify(.1),o=_.now(),Nt.getFullModelDescription(u,.1,.9).always(function(){_.isFunction(Nt.getSupportedStorageExtensions)&&_.each(Nt.getSupportedStorageExtensions(),function(e){e&&_.isString(e.extension)&&g.push(e.extension)}),t({migration:!0})}).done(function(n){function i(e){return t(),J.info("quitHandler(): "+e),!1}n.every(function(t){var n=t.htmlString,u=r+t.extension,d=null,f=null;J.info("quitHandler, created document string with size: "+n.length+". Time for conversion: "+(_.now()-o)+" ms.");try{if(0===h){if(a=r+"_OSN",s=r+"_FILEVERSION",l=r+"_STORAGEVERSION",c=r+"_OPERATIONS",localStorage.setItem(a,e.syncInfo["document-osn"]),localStorage.setItem(l,dn),localStorage.setItem(s,e.syncInfo.fileVersion),d=Nt.getStorageOperationCollector(),_.each(d,function(e){delete e.osn,delete e.opl}),f=JSON.stringify(d),localStorage.setItem(c,f),!localStorage.getItem(c)||localStorage.getItem(c).length!==f.length)return i("failed to save document operations in local storage");J.info("quitHandler(): successfully saved document operations in local storage with key: "+c)}localStorage.setItem(u,n);var g=localStorage.getItem(u);if(!g||g.length!==n.length)return i("failed to save document in local storage");if(J.info("quitHandler(): successfully saved document in local storage with key: "+u),0===h){var p=localStorage.getItem(a),E=p?parseInt(p,10):-1;if(E!==e.syncInfo["document-osn"])return i("failed to save OSN for document in local storage");J.info("quitHandler(): successfully saved OSN for document in local storage with key: "+a+" : "+E)}return h++,!0}catch(e){return i("failed to save document and/or document OSN in local storage")}})}).always(function(){u.notify(1),u.resolve(e)})},"EditApplication.saveFileInStorage")),null===u?e:u.promise()}).progress(t)):a=$.when(),I&&(a=a.then(function(){return v.DEBUG&&mt.debugTypeError.test("async-quithandler"),ut(".disconnect",null,he)})),l&&(h?a=a.then(o,o):"reload"!==e&&("new"===r.action||r.template)&&On.length<=1&&!r.keepFile&&(a=a.then(function(){return u.purgeFile(l)}))),a}function pt(e,t){function n(t){var n=mt.createDeferred("EditApplication.checkCloseDocumentResult"),r=new g(t),a={},s=null,l=null,c=null,d=null;return r.isError()||r.isWarning()?(s=i.getStringOption(t,E.RESTORED_FILEID,null),l=i.getStringOption(t,E.RESTORED_FILENAME,null),c=i.getStringOption(t,E.RESTORED_FOLDERID,null),d=i.getStringOption(t,E.RESTORED_ERRORCODE,"BACKUPDOCUMENT_RESTORE_DOCUMENT_WRITTEN"),_.isString(s)&&_.isString(l)&&_.isString(c)?(d=new g(d===g.CONSTANT_NO_ERROR?{errorClass:g.ERRORCLASS_ERROR,error:"BACKUPDOCUMENT_RESTORE_DOCUMENT_WRITTEN"}:{errorClass:g.ERRORCLASS_ERROR,error:d}),a[E.RESTORED_FILENAME]=l,u.getPath(c).always(function(e){a[E.RESTORED_PATHNAME]=u.preparePath(e),a[E.ORIGINAL_FILEID]=mt.getFileDescriptor().id,mt.updateFileDescriptor({id:s,folder_id:c}),mt.setInternalError(d,p.CLOSE,r,{additionalData:a})})):mt.setInternalError(r,p.CLOSE,null,{additionalData:a}),Nt&&Rt?(mt.registerQuitHandler(function(){n.reject()}),mt.quit=function(e){return function(){return n.reject(),e.call(mt)}}(mt.quit),o.idle(),n.always(function(){o.busy()}),"logout"===e&&n.reject()):n.reject(),r.getDescription()&&J.log(r.getDescription()),n.promise()):t}var o=mt.getWindow();return t=t||null,ut(".closeDocument",t,Ee).then(n,function(e){return"timeout"===e?mt.createRejectedPromise(e):n(e)})}function Et(e){return Tn[e]}function ht(e){var t=_.indexOf(wn,e);return t<0&&(t=wn.length,wn.push(e)),t}function Ot(){se.info("DEBUGGING ***********************************************"),se.info("DEBUGGING: clearLocalActionsWithoutAckAfterEvent: Clearing the local actions!"),se.info("DEBUGGING ***********************************************"),_t()}function _t(){Nt.isProcessingExternalOperations()?(Nt.off("operations:after",Ot),se.info("DEBUGGING ***********************************************"),se.info("DEBUGGING: clearLocalActionsWithoutAck: External operations are currently applied. Coming back later after event operations:after!"),se.info("DEBUGGING ***********************************************"),Nt.on("operations:after",Ot)):Zn>0?(mt.off("docs:ackosn:updated",Ot),Nt.off("operations:after",Ot),se.info("DEBUGGING ***********************************************"),se.info("DEBUGGING: clearLocalActionsWithoutAck: External operations are still missing. Coming back later after event docs:ackosn:updated or operations:after!"),se.info("DEBUGGING ***********************************************"),mt.on("docs:ackosn:updated",Ot),Nt.on("operations:after",Ot)):(se.info("DEBUGGING: Clearing local cache. Before: "+JSON.stringify(zn)),Nt.off("operations:after",Ot),mt.off("docs:ackosn:updated",Ot),at("sentToServer"),se.info("DEBUGGING: Clearing local cache. After: "+JSON.stringify(zn)))}function It(){se.info("DEBUGGING ***********************************************"),se.info("DEBUGGING: sendActionsAfterApplyingExternalOperations: Sending actions after receiving operations:after event!"),se.info("DEBUGGING ***********************************************"),li()}function St(){se.info("DEBUGGING ***********************************************"),se.info("DEBUGGING: sendActionsAfterReceivingRequiredExternalOperations: Sending actions after receiving docs:ackosn:updated event!"),se.info("DEBUGGING ***********************************************"),li()}var mt=this,Nt=null,Rt=null,Dt=null,At=null,vt=null,yt=null,Ct=null,Tt=[],wt=null,bt=!1,Ut=!1,Ft=0,Lt=i.getFunctionOption(s,"preProcessHandler"),Gt=i.getFunctionOption(s,"postProcessHandler"),xt=i.getFunctionOption(s,"fastEmptyLoadHandler"),kt=i.getFunctionOption(s,"previewHandler"),Pt=i.getFunctionOption(s,"importFailedHandler",_.noop),Bt=i.getFunctionOption(s,"optimizeOperationsHandler"),Mt=i.getFunctionOption(s,"mergeCachedOperationsHandler"),Ht=!(!s||!s.otConfigKey)&&v.getFlag(s.otConfigKey,!1),qt=Ht?100:i.getNumberOption(s,"sendActionsDelay",0),jt=i.getBooleanOption(s,"isMultiSelectionApp",!0),$t=i.getBooleanOption(s,"isSnapshotApp",!0),Vt=null,Wt=null,Yt=!1,zt=null,Kt=null,Qt=!1,Zt=!1,Jt=null,Xt=!1,en=!1,tn=!1,nn=null,on=!1,rn=!1,an=!1,sn=null,ln=!1,cn=i.getBooleanOption(s,"localStorageApp",!1)&&!Ht,un=i.getIntegerOption(s,"requiredStorageVersion",0),dn=i.getIntegerOption(s,"supportedStorageVersion",0),fn=!1,gn=v.USE_LOCAL_STORAGE&&!0===ox.secretCookie&&!r.auth_code,pn=!1,En={},hn=1,On=[],_n=[],In=[],Sn=null,mn=0,Nn=!1,Rn=i.getBooleanOption(s,"supportsOnlineSync",!0),Dn=null,An=!1,vn=!1,yn={},Cn="",Tn={},wn=[],bn=!0,Un=!1,Fn=[],Ln=null,Gn=null,xn=!1,kn=!1,Pn=!1,Bn=null,Mn=null,Hn=0,qn=!0,jn=null,$n=null,Vn=!1,Wn="slow load",Yn=!1,zn=[],Kn=0,Qn=null,Zn=-1,Jn=0,Xn=[],ei={},ti=null,ni=null,ii=!1;N.call(this,o,function(){function e(e,t){T.push(t),w.log("Document status update received during document import")}function t(e,t){F.push(t),w.log("Clients update received during document import")}function n(e){var t={},n=[];return _.each(e,function(e){var i=e.operations;$.extend(t,e),i&&(delete e.operations,n=n.concat(i))}),ei=t&&t.syncInfo,w.log("loadDocInfo",ei),t.operations=n,_.isEmpty(t.operations)&&t.syncInfo&&k===parseInt(t.syncInfo["document-osn"],10)&&(x=!0),t}function o(e){var t=0,n=[];return _.each(e,function(e){t=_.isNumber(e.activeSheet)?e.activeSheet:t,n=n.concat(e.operations)}),{preview:{activeSheet:t,operations:n}}}function a(e,t){w.log("Final operation message received for asynchronous load"),Ht&&Qe(t.docStatus.serverOSN),t.hasErrors||"error"===mt.getState()?I.reject(t):N.always(function(){O.push(t),I.resolve(n(O))})}function c(e,t){var n=null;if(Nn)return delete t.actions,O.length>0?O[0]=_.extend(O[0],t):O.push(t),void N.resolve();if(d(t))return R=!0,void O.push(t);if(R&&!y){y=!0,n=o(O),(O=[]).push(t);var i=E(n);return B.asyncStep(i,"previewProcessing","EditApp: Preview data processed"),i.done(function(){N.resolve()}),void i.fail(function(){N.reject(),nt(t)})}R||"pending"!==N.state()||N.resolve(),O.push(t)}function u(n){function o(n,o){return ai(n).always(function(){He(n.docStatus)}),Gn=i.getStringOption(n.syncInfo,"restore_id",null),fn=i.getBooleanOption(n.syncInfo,"renameNeedsReload",!1),mt.waitForImportSuccess(function(){w.log("Applying clients update messages, count = "+F.length),_.each(F,function(e){ai(e)}),w.log("Applying document update messages, count = "+o.length),_.each(o,function(e){Xe(e)}),lt()&&(Ct.off(A.RESPONSE_OPEN_DOC_CHUNK,c),Ct.off(A.RESPONSE_OPEN_DOC,a),Ct.off(A.BROADCAST_UPDATE_CLIENTS,t).on(A.BROADCAST_UPDATE_CLIENTS,function(e,t){ai(t)}),Ct.off(A.BROADCAST_UPDATE,e).on(A.BROADCAST_UPDATE,function(e,t){Xe(t)})),f(),I.resolve({action:[]})}),$.when()}function u(){return mt.getUserInfo(ox.user_id).done(function(e){yt=i.escapeHTML(e.operationName)})}var d=G(n),p=l(n.docStatus),E=new g(n),h=null,O=null;return mt.isViewerMode()&&(tn=!0,ei={},C(!1)),At=i.getStringOption(n.docStatus,"clientId",""),En[At]=0,h=function(){var e=null;return i.getBooleanOption(n,"hasErrors",!1)?(J.error("EditApplication.importHandler - server side error"),e="server"):i.getBooleanOption(n,"operationError",!1)?(J.error("EditApplication.importHandler - operation failure"),e=n.message):E.isError()?(J.error("EditApplication.importHandler - server side error, errorCode="+E.getCodeAsConstant()),e="server"):0===At.length?(J.error("EditApplication.importHandler - missing client identifier"),e="noclientid"):Nn||x||_.isArray(d)&&0!==d.length||(J.error("EditApplication.importHandler - missing document operations"),e="noactions"),e?{cause:e}:null}(),_.isObject(h)?(h=_.extend(h,nt(n)),$.Deferred().reject(h)):function(){function e(){_.each(c,function(e){localStorage.removeItem(i+e.extension)}),localStorage.removeItem(a),localStorage.removeItem(o),localStorage.removeItem(l),localStorage.removeItem(s)}var t=!0,i=null,o=null,a=null,s=null,l=null,c=null;return"load"===r.action&&_.isObject(r.file)?(te&&cn&&gn&&n.syncInfo&&n.syncInfo.fileVersion&&P(n.syncInfo["document-osn"])&&n.syncInfo.fileId&&n.syncInfo.folderId&&_.isFunction(Nt.setFullModelNode)&&_.isFunction(Nt.getSupportedStorageExtensions)&&(i=n.syncInfo.fileId+"_"+n.syncInfo.folderId,l=i+"_FILEVERSION",o=i+"_STORAGEVERSION",a=i+"_OSN",s=i+"_OPERATIONS",c=Nt.getSupportedStorageExtensions(),(localStorage.getItem(o)&&parseInt(localStorage.getItem(o),10)||1)>=un?(J.info("EditApplication.importHandler - document-osn="+n.syncInfo["document-osn"]+", document-rev="+n.syncInfo.fileVersion),localStorage.getItem(l)&&localStorage.getItem(l)===n.syncInfo.fileVersion&&localStorage.getItem(a)&&parseInt(localStorage.getItem(a),10)===parseInt(n.syncInfo["document-osn"],10)?function(){var e=JSON.parse(localStorage.getItem(s));if(!_.isArray(e))return!1;d.length>0&&Nt.setExternalLocalStorageOperationsExist(!0),d=e.concat(d);var t=_.last(d);return _.isNumber(t.osn)||(t.opl=1,t.osn=parseInt(localStorage.getItem(a),10)-1),!0}()?c.some(function(t){var n=i+t.extension,o={usedLocalStorage:!0};_.isObject(t.additionalOptions)&&_.extend(o,t.additionalOptions);var r=localStorage.getItem(n);if(r)J.info("EditApplication.importHandler - loading document from local storage. Key: "+n+" Length: "+localStorage.getItem(n).length),pn=!0,Wn="local storage",Nt.setFullModelNode(r,o);else{if(!t.optional)return J.info("EditApplication.importHandler - key in local storage not found. Key: "+n+". But found OSN key: "+a),e(),pn=!1,!0;J.info("EditApplication.importHandler - optional local storage value not found. Key: "+n)}}):(J.info("EditApplication.importHandler - required operations in local storage not found. Key: "+s),e()):(J.info("EditApplication.importHandler - file in local storage not found. Key: "+i),e())):(J.info("EditApplication.importHandler - version of file in local storage not supported. Key: "+i),e())),pn&&Nt.trigger("update:model",{usedLocalStorage:!0}),t):t}()?(function(){var e=null,t="",o=i.getBooleanOption(n,"fastLoad",!1);pn||(!n.htmlDoc&&v.DEBUG&&!Nn&&Nt.setFullModelNode&&o&&mt.getFileDescriptor()&&!W(mt.getFileDescriptor().filename,"_ox")&&Rt.yell({type:"error",headline:_.noI18n("Error in fastload"),message:_.noI18n('you should have a look in the backend logfiles ("Exception while creating the generic html document")')}),n.htmlDoc&&_.isFunction(Nt.setFullModelNode)&&!Nn&&(J.info("EditApplication.importHandler - load complete HTML document, osn: ",n.syncInfo["document-osn"]),(e=JSON.parse(n.htmlDoc)).mainDocument&&Nt.setFullModelNode(e.mainDocument),e.headerFooter&&(_.each(e.headerFooter,function(e){t+=e}),Nt.setFullModelNode(t,{headerFooterLayer:!0}),Nt.getPageLayout().headerFooterCollectionUpdate()),e.comments&&(t="",_.each(e.comments,function(e){t+=e}),Nt.setFullModelNode(t,{commentLayer:!0})),Wn="fast load",Nt.trigger("fastload:done")))}(),T.unshift({docStatus:p}),Nn?(Wn="fast empty",o(n,T).then(u)):(O=et(Lt,"preProcessing","Import preprocess handler finished"),O=O.then(u).then(function(){var e=et(function(){var e=s&&s.applyActionsDetached;return e&&Rt.detachAppPane(),Nt.applyExternalOperations(d,{expand:!0}).always(function(){e&&Rt&&!Rt.destroyed&&Rt.attachAppPane()})},"applyOperations",d.length+" document operations applied");return e=e.then(function(){var e=null;if(Nt.getOperationStateNumber()<0)return $.Deferred().reject({cause:"applyactions",headline:L("Synchronization Error")});var t=pn&&!Nt.externalLocalStorageOperationsExist();return e=et(Gt?Gt.bind(mt,t):null,"postProcessing","Import postprocess handler finished"),e=e.then(function(){return o(n,T)},function(e){return _.extend({cause:"postprocess"},e)})},function(e){if(lt()&&Ct.off(A.RESPONSE_OPEN_DOC,a),"destroy"!==e)throw _.extend({cause:"applyactions"},e)})},function(e){throw _.extend({cause:"preprocess"},e)}))):$.Deferred().reject({cause:"localStorageFailed",headline:_.noI18n("LocalStorage failure")})}function d(e){return i.getBooleanOption(e,"preview",!1)}function E(e){var t=new g(e),n=i.getObjectOption(e,"preview"),o=t.isError()?$.Deferred().reject(e):$.when();return n&&_.isArray(n.operations)&&(o=function(){var t=et(Lt,"previewPreProcessing","Preview preprocess handler finished");return t=t.then(function(){Lt=null;var t=M(e.preview,"operations"),i=t?Nt.applyExternalOperations(t,{expand:!0}):mt.createResolvedPromise();return B.asyncStep(i,"previewApplyOperations","EditApp: "+t.length+" preview operations applied"),i=i.then(function(){return kt.call(mt,n)?mt.leaveBusyDuringImport():$.when()},function(t){t&&"abort"===t||(e.operationError=!0,e.message=L("An unrecoverable error occurred while modifying the document."))})}),B.asyncStep(t,"previewEnd","EditApp: Preview postprocess handler finished")}()),o}var O=[],I=mt.createDeferred("EditApplication.asynchronousLoadFinished"),S=null,m=null,N=$.Deferred(),R=!1,y=!1,T=[],F=[],x=!1,k=-1,B=mt.launchTracker;return Nt.getUndoManager().on("undogroup:open",function(){wt=it()}),Nt.getUndoManager().on("undogroup:close",function(){ot()&&ci(wt),wt=null,Ht&&Nt.setInternalOperationBlocker(!1)}),Ht&&Nt.getUndoManager().on("undo:after redo:after",function(){Nt.setInternalOperationBlocker(!1)}),Nt.on("operations:success",function(e,t,n){n||Un||(_.isObject(wt)?(w.log("operations:success - push operations into pending action"),wt.operations=wt.operations.concat(t)):ci(it(t)))}),Nt.on("cacheBuffer:flush",function(){w.log("cacheBuffer:flush received - send cached operations"),_.isFunction(Mt)&&Fn.length&&(Tt=Mt.call(mt,Tt,Fn),li())}),Nt.on("operations:error",function(){mt.isImportFinished()?(mt.setInternalError(h.ERROR_WHILE_MODIFYING_DOCUMENT,p.GENERAL),w.error("An unrecoverable error occurred while modifying the document")):(mt.setInternalError(h.ERROR_WHILE_LOADING_DOCUMENT,p.GENERAL),w.error("An unrecoverable error occurred while loading the document"))}),mt.getWindowNode().on("drop",!1),Ct=mt.isViewerMode()?new b(mt,s):new w(mt),this.rtConnection=Ct,Nn||Rt.enterBusy({cancelOnReadOnly:!1,cancelHandler:function(){mt.isInQuit()||(ut(".abortOpen"),ft(),mt.quit())},immediate:!0,topLabel:_.noI18n(mt.getFullFileName()),warningLabel:L("Sorry, your document is very large. It will take some time to be loaded."),warningDelay:1e4}),lt()&&(Ct.on(D.EVENT_OFFLINE,Re),Ct.on(D.EVENT_ONLINE,De),Ct.on(D.EVENT_ERROR,function(e,t){ye(t,I)}),Ct.on(D.EVENT_NORESPONSE_IN_TIME,Te),Ct.on(A.BROADCAST_UPDATE,e),Ct.on(A.BROADCAST_UPDATE_CLIENTS,t),Ct.on(A.BROADCAST_SHUTDOWN,we),Ct.on(A.BROADCAST_CRASHED,be),Ct.on(A.BROADCAST_RENAMED_RELOAD,Le),Ct.on(A.BROADCAST_HANGUP,Ue)),B.step("initImport","EditApp: Import process initializated"),m=tt(),oi(),(S=m.then(function(e){var t=new g(e),n={fastEmpty:Nn};if(!t.isError())return lt()&&(Ct.on(A.RESPONSE_OPEN_DOC_CHUNK,c),Ct.on(A.RESPONSE_OPEN_DOC,a)),r.auth_code&&(n=_.extend({auth_code:r.auth_code},n)),e&&e.advisoryLock&&(n=_.extend({advisoryLock:e.advisoryLock},n)),"new"===r.action&&(n=_.extend({newDoc:!0},n)),Nn&&(n=_.extend({fastEmptyOSN:Nt.getOperationStateNumber()},n)),te&&!Nn&&gn&&(U(r,n),k=n.storageOSN),lt()&&Ct.open(n),I.then(u,function(e){return j(nt(e))});nt(e)}).catch(function(e){return j(nt(e))})).always(function(){Sn=null,f()}),S},r,_.extend({},s,{initHandler:function(){var e=Nt.getFontCollection().importReplacementFonts();return v.DEBUG&&(e=e.then(function(){return Z("io.ox/office/debug/common/main",function(e){return e.initializeApp(mt)})})),e},initFileHandler:function(){function e(e){return mt.setInternalError(e,p.CREATEDOC),$.Deferred().reject({cause:n?"convert":"create"})}if(!mt||!r)return J.warn("EditApplication.initFileHandler() called on an already destroyed instance."),$.Deferred().reject();var t={},n=!1,o=mt.launchTracker;switch(r.cryptoAction&&(t.cryptoAction=r.cryptoAction),r.decrypt_auth_code&&(t.cryptoAuth=r.decrypt_auth_code,t.encrypted_file=!0),i.getStringOption(r,"action","load")){case"load":return u.getFile(r.file).done(function(e){r.file=e});case"convert":n=!0;break;case"new":s&&s.newDocumentParams&&_.extend(t,s.newDocumentParams);break;default:return J.error("EditApplication.initFileHandler(): unsupported launch action"),$.Deferred().reject()}var a=i.getObjectOption(r,"templateFile"),l=i.getBooleanOption(r,"preserveFileName",!1),c=i.getStringOption(r,"target_filename",pe),d=i.getStringOption(r,"target_folder_id",""),f=i.getObjectOption(a,"origin");_.extend(t,{action:"createdefaultdocument",document_type:mt.appType,target_filename:c,target_folder_id:d,preserve_filename:l,convert:n}),r.template&&_.extend(t,{action:"createfromtemplate",file_id:a.id}),_.isObject(a)&&_.extend(t,{file_id:a.id,version:a.version}),mt.waitForImportSuccess(function(){var e=mt.getFileDescriptor(),t=!r.template&&d!==e.folder_id;(r.template?e.converted:n)?mt.setCurrentInfoState(t?O.INFO_DOC_CONVERT_STORED_IN_DEFFOLDER:O.INFO_DOC_CONVERTED_AND_STORED):t&&mt.setCurrentInfoState(O.INFO_DOC_CREATED_IN_DEFAULTFOLDER)});var E=_.url.hash("fields"),h=_.url.hash("fields-source");(E||h)&&(_.url.hash("fields",null),_.url.hash("fields-source",null),t.fields=E,t.sourcefields=h);var I=mt.sendRequest(Q,t);return I=I.then(function(t){var n=new g(t);return n.isError()?e(n):t},function(){return e()}),o.asyncStep(I,"createNewDocAfterRequest","EditApp: New file in remote storage created"),I=I.then(function(e){return u.getFile(e.file).then(function(t){return e.file=t,e})}),(I=I.then(function(e){function t(e,t){var n=mt.isPresentationApp()?mt.createResolvedPromise():mt.leaveBusyDuringImport(!e,{immediateShow:!0});return o.asyncStep(n,"afterLeaveBusyEarly","EditApp: Busy state after creation of document left"),n.then(function(){if(e)return t;throw t},function(n){throw e?n:t})}return _.isObject(e.file)?(f&&(e.file.origin=f),e.file.source="drive",e.converted&&(e.file.converted=e.converted),(Nn=_.isString(e.htmlDoc)&&_.isArray(e.operations)&&e.operations.length>0)&&xt?xt.call(mt,e.htmlDoc,e.operations).then(t.bind(null,!0),t.bind(null,!1)).then(function(){return e}):e):(J.error("EditApplication.initFileHandler(): missing file descriptor"),$.Deferred().reject())})).then(function(e){return e.file})},flushHandler:function(e){if(on)return j();var t=st(e);return t=t.then(function(){return lt()?Ct.flushDocument():j()})},messageDataHandler:x,printOptionsHandler:function(){return lt()?{doc_uid:Ct.getDocUID(),client_uid:Ct.getClientUID()}:null}}));var oi=v.DEBUG?function(){gn=mt.getUserSettingsValue("debugUseLocalStorage",gn)&&!mt.isDocumentEncrypted()}:$.noop,ri=v.LOG_PERFORMANCE_DATA?function(){var e=Rt.getToolBarTabs(),t=0;e.on("tab:activated",function n(i,o){if(t++,o){var r="tabActivated_"+z(o);mt.launchTracker.step(r,'EditApp: Toolbar tab "'+o+'" activated')}2===t&&e.off("tab:activated",n)})}:$.noop;this.getServerModuleDocUrl=function(e,t,n){if(!lt()||!ox.session||!this.hasFileDescriptor())return null;var i=this.getFileParameters(_.extend({},n,{encodeUrl:!0}));return t=_.extend({session:ox.session,uid:this.get("uniqueID"),docuid:Ct.getDocUID()},i,t),ox.apiRoot+"/"+e+"?"+_.map(t,function(e,t){return t+"="+e}).join("&")};var ai=this.createSynchronizedMethod("EditApplication.applyUserData",function(e){ce.log("$back(PaleGoldenRod)applyUserData - CLIENT UPDATE",e);var t=null;if(_.isArray(e)?(t={clients:{changed:[]}},_.each(e,function(e){t.clients.changed.push({clientUID:e})})):t=e,!_.isObject(t))return J.error("applyUserData called without valid data: "+JSON.stringify(t)),$.when();var n=_n,o=i.getObjectOption(t,"clients",{}),r=[],a=[];if(sn===At&&_.isArray(o.changed)&&o.changed.length>0&&xe({activeUsers:o.changed}),_.isArray(o.list))a=o.list;else if(_.isArray(o.left)||_.isArray(o.joined)||_.isArray(o.changed)){var s={};_n.forEach(function(e){s[e.clientUID]=e}),_.isArray(o.left)&&o.left.forEach(function(e){delete s[e]}),_.isArray(o.joined)&&o.joined.forEach(function(e){s[e.clientUID]=e}),_.isArray(o.changed)&&o.changed.forEach(function(e){s[e.clientUID]=_.extend({},s[e.clientUID],e)}),Object.keys(s).forEach(function(e){a.push(s[e])})}return 0===a.length?$.when():(_.each(a,function(e){var t=_.isObject(e)&&_.isString(e.clientUID),n=t&&!_.isNumber(e.userId)&&_.isNumber(e.id);t?n?r.push(mt.getUserInfo(e.id).then(function(t){return e.userDisplayName=t.displayName,e.userOperationName=t.operationName,e})):r.push($.when(e)):J.warn("EditApplication.applyUserData(): missing identifier")}),mt.createResolvedPromise().then(function(){return $.when.apply($,r)}).done(function(){if(On=_.map(arguments,function(e){var t=e;return _.isNumber(e.userId)||((t={}).clientUID=e.clientUID,t.userId=e.id,t.userName=e.userDisplayName,t.userOperationName=e.userOperationName,t.guest=e.guest),t.active=!0===e.active||_.isNumber(e.durationOfInactivity)&&e.durationOfInactivity<60,t.remote=At!==t.clientUID,t.editor=sn===t.clientUID,_.isObject(e.userData)&&(t.userData=e.userData),t.clientUID in En||(En[t.clientUID]=hn,hn+=1),t.clientIndex=En[t.clientUID],t.colorIndex=mt.getAuthorColorIndex(t.userOperationName),t}),_n=_.where(On,{active:!0}),_n=_.sortBy(_n,"clientIndex"),!_.isEqual(n,_n)){J.info("EditApplication.applyUserData(): activeClients=",_n),We(n,_n)||mt.trigger("docs:users",_n),Mn&&!_.findWhere(_n,{clientUID:Mn.clientUID})&&Pe();var e=_.first(_.pluck(_.where(n,{clientUID:At}),"requestsEditRights")),t=_.first(_.pluck(_.where(_n,{clientUID:At}),"requestsEditRights"));!0===e&&!1===t&&(ce.log("$back(PaleGoldenRod)__applyUserData - REQUEST_EDITRIGHTS FOR USER -> is false - > event spinner off",e,t,sn!==At),ke(),sn!==At?(ce.log("$back(PaleGoldenRod)__applyUserData - YOUR REQUEST WAS DECLINED"),Rt.yell({message:L("Your request for edit rights has been declined.")})):Hn=_.now()),mt.trigger("docs:users:selection",_n)}}))}),si=this.createSynchronizedMethod("EditApplication.applyUpdateMessageData",function(e){if(Je(G(e)))return Ht?mt.setInternalError(h.ERROR_SYNCHRONIZATION_NOT_POSSIBLE_LOCAL_CHANGES,p.CONNECTION):mt.restoreDocument(new g(h.ERROR_SYNCHRONIZATION_LOST_EDIT_RIGHTS)),$.when();var t=Ze(e);return t.done(function(t){_.isObject(e)&&!_.isObject(e.docStatus)&&J.error("broadcast_update sent bad data "+JSON.stringify(e)),Ht&&t&&t.cached||(He(e.docStatus),Ve(e))}),t}),li=function(){function e(){if(v.REALTIME_DEBUGGING&&ln&&Tt&&Tt.length>0){var n=Tt[Tt.length-1].operations;n&&n.length>0&&J.log("EditApplication.sendActionsBuffer(): last action:",_.last(n))}if(Ht&&Yn)return mt.executeDelayed(function(){e()},"sendActionsBuffer",1e3),void t.resolve();if(Bt){var i=Ht?Tt.length:0;Tt=Bt.call(mt,Tt),Ht&&Tt.length!==i&&at("_OPTIMIZED_OPERATION_")}Tt=y.handleMinifiedActions(Tt);var o=null;Ht?(zn.forEach(function(e){e.sentToServer=!0}),se.info("DEBUGGING ***********************************************"),se.info("DEBUGGING Sending action with operation base OSN: "+Kn),se.info("DEBUGGING Sending actions: "+JSON.stringify(Tt)),se.info("DEBUGGING ***********************************************"),o=lt()?Ct.sendActions(Tt,!1,Kn):mt.createRejectedPromise()):o=lt()?Ct.sendActions(Tt):mt.createRejectedPromise(),o.done(function(n){if(Ht){se.info("DEBUGGING ***********************************************"),se.info("DEBUGGING: Receiving acknowledge with new OSN sent from server: "+n.body.serverOSN),Qe(n.body.serverOSN,!0),se.info("DEBUGGING ***********************************************"),se.info("DEBUGGING: Trying to clear local operation cache after receiving acknowledge"),_t()}on?(w.error("EditApplications.sendActionsBuffer(): sent successfully, but internal error detected!"),t.reject()):0===Tt.length?t.resolve():Ht&&Nt.isProcessingExternalOperations()?(se.info("DEBUGGING ***********************************************"),se.info("DEBUGGING: sendActionsBuffer: External operations are currently applied. Calling sendActions later in operations:after handler!"),se.info("DEBUGGING ***********************************************"),Nt.one("operations:after",It),t.resolve()):Ht&&Zn>0?(se.info("DEBUGGING ***********************************************"),se.info("DEBUGGING: sendActionsBuffer: External operations are still missing. Calling sendActions later in operations:after handler!"),se.info("DEBUGGING ***********************************************"),Nt.one("operations:after",It),t.resolve()):e()}).fail(function(e){w.error("EditApplications.sendActionsBuffer(): rtConnection.sendActions promise failed!"),t.reject(e)}),Tt=[]}var t=null;return function(){if(w.log("EditApplication.sendActions(): entered"),bt)return w.log("EditApplication.sendActions(): sending in progress - using current promise"),t.promise();if(on)return w.error("EditApplication.sendActions(): internal error detected - promise rejected!"),$.Deferred().reject();if(Ht&&le(Tt,zn),0===Tt.length)return w.log("EditApplication.sendActions(): no need to send action buffer empty"),$.when();if(Ht){if(Zn>=0)return se.info("DEBUGGING ***********************************************"),se.info("DEBUGGING: sendActions: Not all external operations are currently applied. Coming back later, when all external ops are applied!"),se.info("DEBUGGING ***********************************************"),mt.once("docs:ackosn:updated",St),t.promise();if(Nt.isProcessingExternalOperations())return se.info("DEBUGGING ***********************************************"),se.info("DEBUGGING: sendActions: External operations are currently applied. Coming back later in operations:after handler!"),se.info("DEBUGGING ***********************************************"),Nt.one("operations:after",It),t.promise()}return t=mt.newDeferred("EditApplication.sendActions").always(function(){w.log("EditApplication.sendActions(): current send promise resolved - sendingActions = false"),bt=!1,Ft=_.now(),f()}),bt=!0,f(),e(),t.promise()}}(),ci=function(){var e=mt.createDebouncedMethod("EditApplication.storeAndSendDebounced",function(e){var t=!1;w.withLogging(function(){var t=e.operations.length>0?JSON.stringify(_.last(e.operations)):null;w.log("EditApplication.storeAction(): "+(t?"last operation: "+t:"no operations provided"))}),Mt&&Fn.length>0&&(Tt=Mt.call(mt,Tt,Fn),Mt=null,Fn=[],t=!0),!on&&(e.operations.length>0||t)&&(e.operations.length>0&&(Tt.push(e),Ht&&(zn.push(e),se.info("DEBUGGING: Adding local action to local operation cache: "+JSON.stringify(zn)))),Qt=!0,Ut=!0,f())},li,{delay:qt,maxDelay:qt});return function(t){bn?e(t):(w.log("EditApplication.registerAction(): cached action during non-distribution mode"),Fn.push(t))}}(),ui=_.once(function(){if(ii=!0,C(!1),lt()){var e=s&&s.prepareLeaveDataHandler,t=e?e.call(mt):null;Ct.emergencyLeave(t)}});this.leaveBusyDuringImport=_.once(function(e,t){return Sn=mt.launchTracker.step("previewStart","EditApp: Busy state during import process left"),f(),Rt.showAfterImport(e,t)}),this.getLaunchOption=function(e){return r&&r[e]},this.createDebouncedActionsMethodFor=function(e,t,n,i,o){var r=!1;return e.createDebouncedMethod(t,n,function(){if(!r){if(!mt.isImportFinished()||!Nt.isProcessingActions())return i.call(e);var t=Nt.waitForActionsProcessed();r=!0,e.waitForSuccess(t,function(){r=!1,i.call(e)})}},o)},this.checkStartOfExternalOperations=function(){!Ht||wt||Nt.isProcessingInternalOperations()||mt.trigger("docs:operations:completed")},this.isRemovalOfInternalBlockerPossible=function(){return Ht&&!wt},this.getFileFormat=function(){var e;return null===vt&&(e=this.hasFileDescriptor()?this.getFullFileName():r&&r.templateFile?r.templateFile.filename:"",vt=e?R.getFileFormat(e):null),vt||"ooxml"},this.isOOXML=function(){return"ooxml"===this.getFileFormat()},this.isODF=function(){return"odf"===this.getFileFormat()},this.isTemplateFile=function(){return this.hasFileDescriptor()&&R.isTemplate(this.getFullFileName())},this.isScriptable=function(){return this.hasFileDescriptor()&&R.isScriptable(this.getFullFileName())},this.isShutdownReceived=function(){return!1},this.getClientId=function(){return At},this.getShortClientId=function(){return At.slice(0,4)},this.getDocUID=function(){return lt()?Ct.getDocUID():null},this.getLoadMode=function(){return Wn},this.getEditClientId=function(){return sn},this.getEditClientUserName=function(){return Ie(sn)},this.getClientOperationName=function(){return yt},this.getPendingActions=function(){return Tt},this.resetPendingActions=function(){Tt=[]},this.getActiveClients=function(){return _n},this.isLocallyModified=function(){return Qt},this.isPrepareLosingEditRights=function(){return ln},this.sendActionRequest=function(e,t,n){return lt()?(n=_.extend({method:"POST"},n),this.sendFileRequest(Q,{action:e,docuid:Ct.getDocUID(),requestdata:JSON.stringify(t)},n)):mt.createRejectedPromise()},this.sendQueryRequest=function(e,t,n){return this.sendActionRequest("query",_.extend({},t,{type:e}),n)},this.sendAddImageIdRequest=function(e){return lt()?Ct.addImageId(e):$.when()},this.sendLogMessage=v.LOG_ERROR_DATA?function(e){return mt&&mt.allowStoreLogFile()&&mt.sendLogErrorData({errorCode:e}),this}:i.NOOP,this.isRenameEnabled=function(){return!ne&&(!fn&&!v.getDebugFlag("office:simple-filestore")||!this.isDocumentEncrypted()&&!Ht)},this.rename=function(e){var t=this.getFileDescriptor(),n=i.getStringOption(t,"filename",this.getFullFileName()),o=i.getStringOption(t,"com.openexchange.file.sanitizedFilename",n),r=Y(e);if(this.setUnsavedFileName(null),Jt)return J.warn("EditDocument.rename(): multiple calls, ignoring subsequent call"),Jt;if(0===r.length)return $.Deferred().reject();if(r===this.getShortFileName())return $.when();r+="."+this.getFileExtension(),this.isDocumentEncrypted()&&(r+=u.GUARD_EXT),this.updateFileDescriptor({filename:r}),Ln=this.createDeferred("EditApplication.renameAndReload",{background:!0});var a=s&&s.prepareRenameHandler;return Jt=a?V(a.bind(mt)):q(),Jt=Jt.then(li),Jt=Jt.then(function(){return lt()?Ct.renameDocument({target_filename:r}):j()}),(Jt=Jt.then(function(e){var t=new g(e);return t.isWarning()&&"RENAMEDOCUMENT_SAVE_IN_PROGRESS_WARNING"===t.getCodeAsConstant()?Ln.promise():t.isError()?j(t):e})).done(function(e){Xt=!0,mt.updateFileDescriptor({filename:i.getStringOption(e,"fileName",n),"com.openexchange.file.sanitizedFilename":i.getStringOption(e,"com.openexchange.file.sanitizedFilename",o)})}),Jt.fail(function(e){if("abort"!==e){var t=g.isErrorCode(e)?e:new g(e);t.setErrorContext(p.RENAME);var i=I.getMessageData(t);i.restoreHidden=!1,J.warn("EditApplication.rename() error: "+t.getErrorText()),Rt.yell(i)}mt.updateFileDescriptor({filename:n})}),Jt.always(function(){Jt=null})},this.getCurrentFileName=function(){return Jt?Rt.getToolbarFileNameFieldValue():mt.getShortFileName()},this.hasUnsavedChangesOffice=function(){return rt()||!!Jt||this.hasUnsavedFileName()||!!Nt&&Nt.hasUnsavedComments()},this.hasUnsavedChanges=function(){return(!ox.tabHandlingEnabled||n.getLoggingOutState()!==n.LOGGING_OUT_STATE.FOLLOWER)&&(!(!lt()||!Ct.isConnected())&&(this.hasUnsavedChangesOffice()||Ct.hasPendingActions()))},this.setUserState=function(e){return this.isInternalError()||Wt===e||(Wt=e,d()),this},this.getState=function(){return Wt&&!this.isInternalError()?Wt:Vt},this.isEditable=function(){return Kt},this.isOnline=function(){return"offline"!==Vt},this.isInternalError=function(){return"error"===Vt},this.setInternalError=function(e,t,n,o){var r,a=g.isErrorCode(e)?e:new g(e),s=null,l=null,c=null,u=!0,d=i.getObjectOption(o,"additionalData",{}),p=g.isErrorCode(n)?n:a,E=!1,h=i.getObjectOption(o,"silentShutdownConfig",{}),O=a.isError();if(_.isString(t)&&a.setErrorContext(t),s=mt.getErrorState(),(r=!_.isObject(s)||!s.isError())?(mt.setErrorState(a),E=!0):_.isObject(s)&&(a=s,l=jn),c=mt.getErrorState(),g.isErrorCode(c)&&J.error("Internal error: "+c.getErrorText()),O)on=!0,Yt=!1,tn=!0,C(!1),ft(h);else{var S=!_.has(yn,a.getCodeAsConstant()),m=Cn!==a.getCodeAsConstant();u=S&&m,I.isOnceWarning(a.getCodeAsConstant())&&(yn[a.getCodeAsConstant()]=!0),Cn=a.getCodeAsConstant()}f(a),_.isObject(l)&&!E||(l=I.getMessageData(a,_.extend({causeError:p,viewerMode:mt.isViewerMode()},F(),d)),mt.extendMessageData(l),kn="document/reload"===i.getStringOption(l.action,"itemKey"),jn=l),i.getBooleanOption(o,"showMessage",!0)&&u&&Rt&&Rt.yell&&Rt.yell(l),O&&r&&(mt.sendLogErrorData({errorCode:l.errorCode}),mt.allowStoreLogFile()&&mt.createLogFileInDrive())},this.createLogFileInDrive=function(){var e=mt.generateLogData();if(e){var t=new re(this.getWindowId(),L("A debug report is uploaded to Drive/myFiles/crashdata. This can take a while. Closing the browser tab cancels the upload. The report may contain content of previously opened documents."),{title:L("Generating debug report"),classes:"generate-log-dialog",okLabel:L("Close ")}),n=$('<div style = "padding: 10px 0; text-align: center; font-weight: 400; font-size: 14px" class="result">').html('<div class="busy-indicator io-ox-busy"></div>');t.append(n),t.show(),mt.sendLogErrorData({logData:e}).done(function(){n.html('<i class="fa fa-check" aria-hidden="true"></i><span>Finished upload</span>')}).fail(function(){n.html('<i class="fa fa-exclamation-circle" aria-hidden="true"></i><span>Could not upload file</span>')})}},this.allowStoreLogFile=function(){return v.LOG_ERROR_DATA&&!!mt&&!mt.isDocumentEncrypted()},this.sendLogErrorData=function(e){function t(e){return o?"hidden":e}var n=_.has(e,"errorCode"),i=_.has(e,"logData");if(!n&&!i)return mt.createRejectedPromise();var o=!v.LOG_ERROR_DATA,r=mt.getFileDescriptor(),a={action:"logclientdata",logAnonymous:String(o),fileId:String(t(r&&r.id)),folderId:String(t(r&&r.folder_id)),fileName:String(t(mt.getFullFileName())),userId:String(ox&&ox.user_id),docUid:String(ti),errorCode:n?function(){var t=e&&e.errorCode,n=t||"unknownError";return String(n)}():"",logData:i&&mt.allowStoreLogFile()?function(){var t=e&&e.logData;return String(t)}():""};return mt.sendRequest("oxodocumentfilter",a,{method:"POST",dataType:"xml"})},this.setCurrentInfoState=function(e,t){var n=null,o=i.getBooleanOption(t,"showMessage",!0),r=null;i.getBooleanOption(t,"resetWarning",!1)&&(r=mt.getErrorState(),_.isObject(r)&&r.isError()||mt.setErrorState(new g)),mt.setInfoState(e),o&&(n=S.getMessageData(e,_.extend({},F(),t)),mt.extendMessageData(n),_.isObject(n)&&Rt.yell(n))},this.isLocked=function(){return on||tn},this.isAcquireEditRightsEnabled=function(){return!Ht&&lt()&&!this.isLocked()&&this.isOnline()&&!Kt},this.isAcquireEditRightsEnabledPendingUpdates=function(){return this.isAcquireEditRightsEnabled()&&In.length<=1},this.acquireEditRights=function(){ce.log("$back(Orchid)acquireEditRights - User wants to acquireEditRights -> Button pressed  ");{if(this.isAcquireEditRightsEnabled())return Bn.start();ke()}},this.saveDocumentAs=function(t,n,o,a){var s=n,l=null,c=mt.getFileDescriptor(),d=null,f=!1;switch(o){case ee.NATIVE:if(a&&a.encrypted){s+="."+mt.getFileExtension()+u.GUARD_EXT,d=(d=(d=u.authorizeGuard().then(function(e){r.auth_code=e},function(){return f=!0,j()})).then(function(){return mt.flushDocument(ae.DOWNLOAD)})).then(function(){var e=c.file_options||{},n=e.params||{};return _.extend(n,{cryptoAction:"Encrypt",filedisplay:s,ignoreWarnings:!1}),c.file_options=_.extend(e,{params:n}),u.copyFile(c,t)});break}case ee.TEMPLATE:s+="."+mt.getFileExtension(),d=(d=mt.flushDocument(ae.DOWNLOAD)).then(function(){return lt()?Ct.copyDocument({file_id:mt.getFileParameters().id,target_filename:n,asTemplate:o===ee.TEMPLATE,target_folder_id:t}):j()});break;case ee.PDF:s+=".pdf",d=(d=(d=mt.flushDocument(ae.DOWNLOAD)).then(function(){return u.propagateChangeFile(c)})).then(function(){return u.getFileModelFromDescriptor(c).then(function(n){return e.sendConverterRequest(n,{documentformat:"pdf",saveas_filename:s,saveas_folder_id:t})})});break;default:return J.error('EditApplication.saveDocumentAs - unknown file type "'+o+'"'),j()}return d=d.then(function(e){var t=new g(e);return t.isError()?j(t):e}),d=d.then(function(e){return s=i.getStringOption(e,"filename")||s,u.deleteFromCache(t),u.getPath(t).then(function(t){return l=u.preparePath(t),e})}),(d=d.then(function(e){if(o!==ee.PDF){C(!1),o===ee.TEMPLATE&&mt.setCurrentInfoState(O.INFO_DOC_SAVED_AS_TEMPLATE,{fullFileName:s,fullPathName:l,type:"success",duration:1e4});var n=i.getStringOption(e,"id",null);return!n&&a&&a.encrypted&&(n=_.isArray(e)?i.getStringOption(_.first(e),"data",null):e),t=t||i.getStringOption(e,"folder_id",null),u.getFile({id:n,folder_id:t}).done(function(e){e.title=u.getFileBaseName(e.filename),mt.updateFileDescriptor(e),r.action="load",delete r.template,mt.reloadDocument()})}mt.setCurrentInfoState(O.INFO_DOC_SAVED_IN_FOLDER,{fullFileName:s,fullPathName:l,type:"success",duration:1e4})})).fail(function(e){"cancel"===e||f||((e=g.isErrorCode(e)?e:new g(g.GENERAL_ERROR)).setErrorContext(p.SAVEAS),J.warn('EditApplication.saveDocumentAs(): Error code "'+e.getCodeAsConstant()+'"'),Rt.yell(I.getMessageData(e,F())))}),d},this.isReloadEnabled=function(){return kn},this.reloadDocument=function(e){var t=this.getFileDescriptor(),n=this.getFullFileName(),i=R.getEditModule(n);return i?R.isNative(n)?(e=_.extend({},e,{action:"load",file:t}),r.auth_code&&(e.auth_code=r.auth_code),this.quit("reload").done(function(){window.setTimeout(function(){ox.launch(i+"/main",e)},500)})):(J.error("EditApplication.reloadDocument(): unsupported document type"),this):(J.error("EditApplication.reloadDocument(): unknown application type"),this)},this.restoreDocument=function(e,t){var n=i.getArrayOption(t,"actions",null),o=mt.getFileDescriptor(),r=null;if(v.RESTORE_DOCUMENT_ENABLED){if(!xn){if(xn=!0,qn=!1,_.isNull(n)){var a=y.handleMinifiedActions(mt.getPendingActions());r=lt()?function(e,t){var n=y.getActionsArray(e),i=y.getActionsArray(t);return _.isArray(n)&&_.isArray(i)?n.concat(i):n}(Ct.getPendingActions(),a):a}else r=n;tn=!0,C(!1),f(),on=!0;var s={action:"saveaswithbackup",file_id:o.id,target_filename:o.filename,target_folder_id:o.folder_id,restore_id:Gn,operations:_.isNull(r)?r:JSON.stringify(r)};mt.sendFileRequest(Q,s,{method:"POST"}).then(function(t){var n=new g(t),o=mt.newDeferred("EditApplication.restoreDocument"),r=i.getStringOption(t,E.RESTORED_FILEID,null),a=i.getStringOption(t,E.RESTORED_FILENAME,null),s=i.getStringOption(t,E.RESTORED_FOLDERID,null),l=null,c={};_.isObject(t)&&_.isString(a)&&_.isString(s)?u.getPath(s).always(function(e){l=u.preparePath(e),o.resolve(l)}):o.resolve(null),o.always(function(t){var i=_.isString(t);n.isError()||(n=new g({errorClass:g.ERRORCLASS_ERROR,error:"BACKUPDOCUMENT_RESTORE_DOCUMENT_WRITTEN"})),c[E.RESTORED_FILENAME]=a,c[E.RESTORED_PATHNAME]=l,c[E.ORIGINAL_FILEID]=mt.getFileDescriptor().id,i&&mt.updateFileDescriptor({id:r,folder_id:s}),mt.setInternalError(n,e.getErrorContext(),e,{additionalData:c})})},function(){mt.setInternalError(e)})}}else mt.setInternalError(e)},this.rejectEditAttempt=function(e){if(mt.isViewerMode())return this;switch(e){case"image":Rt.yell({message:L("The image could not be inserted.")});break;case"siri":mt.setInternalError(h.ERROR_SIRI_NOT_SUPPORTED,p.GENERAL);break;case"loadingInProgress":mt.setCurrentInfoState(O.INFO_LOADING_IN_PROGRESS);break;default:mt.isImportFinished()?H():mt.setCurrentInfoState(O.INFO_LOADING_IN_PROGRESS)}return this},this.getUserInfo=function(e){return this.createResolvedPromise().then(function(){return t.get({id:e})}).then(function(e){var t=!!e.guest_created_by,n=_.noI18n(e.display_name||e.email1||""),i=t?"User "+e.user_id:e.first_name&&e.last_name?_.noI18n(e.first_name+" "+e.last_name):e.last_name?_.noI18n(e.last_name):e.first_name?_.noI18n(e.first_name):n;return{id:e.user_id,displayName:n,operationName:i,guest:t}})},this.updateUserData=function(){var e=null;return mt.createDebouncedMethod("EditApplication.updateUserData",function(t){return e=t,this},function(){!lt()||"resolved"!==mt.getImportFinishPromise().state()||on||mt.isInQuit()||Ct.updateUserData("updateuserdata",e)},{delay:500,maxDelay:1e3})}(),this.registerAuthorItem=function(e){if("authorId"in e&&"authorName"in e){var t=e.authorId,n=(_.isFinite(t)||_.isString(t))&&i.getStringOption(e,"authorName","").trim()||"";n&&(Tn[t]={id:t,name:n,initials:i.getStringOption(e,"initials","").trim()||null,providerId:i.getStringOption(e,"providerId","").trim()||null,userId:i.getStringOption(e,"userId","").trim()||null})}},this.getRegisteredAuthorItemById=function(e){return Et(e)},this.getAuthorColorIndex=function(e){return a.getSchemeColor(ht(e))},this.addAuthors=function(e){return wn=_.union(wn,e),this},this.stopOperationDistribution=function(e){return bn=!1,mt.convertToPromise(e.call(mt)).always(function(){bn=!0})},this.isOperationsBlockActive=function(){return Un},this.enterBlockOperationsMode=function(e){Un=!0,ot()&&(mt.trigger("docs:operations:remove",wt.operations.length),wt=it()),e.call(mt),Un=!1},this.isMultiSelectionApplication=function(){return jt},this.isSnapshotApp=function(){return $t},this.isFirstTabActivated=function(){return Pn},this.getLoadDocInfo=function(){return ei},this.isOTEnabled=function(){return Ht},this.getOTManager=function(){return Dt||(Dt=o.createOTManager(this.docModel))},this.transformPositionWithLocalActions=function(e,t){return this.getOTManager().transformPosition(e,zn,t)},this.getOTStatistics=function(){return{extOpCount:Jn,otCount:Dt?Dt.getTotalCount():0}},this.setOTBlockingOpsMode=function(e){Yn=e},this.isOTBlockingOpsMode=function(){return Yn},this.hasLocalActionsWithoutAck=function(){return Ht&&zn.length>0},this.getServerOSN=function(){return Kn},this.generateLogData=function(){var e=X();if(!e)return"";var t=navigator.userAgent,n=ti,i=ni,o=this.getFullFileName();return t+"\ndoc_uid: "+n+"\nclient_uid: "+i+"\napp: "+this.appType+"\nfileName: "+o+"\n \n"+e},this.debugTypeError=v.DEBUG?{testPlace:null,activateTestPlace:function(e){this.testPlace=e},test:function(e){this.testPlace===e&&(J.info("You should see a typeError now at",e),this.debugxyz.debugTypeErrorXYZ())}}:$.noop,(Bn=new ue(this)).startHook.on(function(){mt.trigger("docs:acquireeditrights:start")}),Bn.finishHook.on(function(){mt.trigger("docs:acquireeditrights:end")}),Qn=new oe(function(){return lt()?Ct.syncStable().catch(_.noop):q()},{delay:3e4,interval:3e4,windowId:this.getWindowId(),contextMsg:"EditApplication.osnBeacon",background:!0}),this.onInit(function(){Nt=this.docModel,Rt=this.docView,this.waitForImport(function(){mn=mt.launchTracker.step("triggerImportSuccess","EditApp: End of import process notified"),Hn=mn,w.log("Load-mode:",Wn)}),f(),ri(),Se(),this.listenTo(Nt,"operations:error",function(){C(!1)}),this.on("docs:operations:completed",Ke),R.supportsEditMode(mt.appType)||(tn=!0,C(!1),f(),H(R.DOM_TEXT_EDIT_ALERT,-1)),cn&&gn&&(J.info("EditApplication.onInit(): saving document to local storage is active"),te?J.info("EditApplication.onInit(): current browser supports local storage"):J.warn("EditApplication.onInit(): current browser does not support local storage")),this.on("docs:flush:success",function(){Ut=!1}),c.BROWSER_TAB_SUPPORT&&(Nt.listenTo(c.hideTabHook,function(){Ut&&mt.flushDocument(ae.USER)}),Nt.listenTo(c.showTabHook,function(){_.browser.Safari&&Rt.grabFocus({restoreBrowserSelection:!0})}))},this),this.registerBeforeUnloadHandler(function(e){e||ui()}),this.registerUnloadHandler(function(){ui()}),this.registerBeforeQuitHandler(function(){if(v.DEBUG&&mt.debugTypeError.test("sync-beforeQuitHandler"),on)return q();var e=mt.isOnline()&&mt.hasUnsavedFileName()?mt.rename(mt.getUnsavedFileName()):q();return e=e.then(function(){return mt.isOnline()?st(ae.QUIT):null}),e=e.then(function(){return Ye()&&mt.hasUnsavedChangesOffice()?Rt.showQueryDialog(null,L("This document contains unsaved changes. Do you really want to close?")):void 0})}),this.registerQuitHandler(function(e){function t(){return $.when($n).always(function(){w.log("EditApplication.quitHandler.finalizeRTConnection called"),ct()})}function n(){try{if(w.log("EditApplication.quitHandler.connectionGateKeeper entered"),!lt())return;if(dt())return;var e=Ct.getCloseLeaveState();switch(w.log("EditApplication.quitHandler.connectionGateKeeper - connectionOpenState:",e),e){case"unknown":return void ft();case"closing":case"closed":return void ft({skipCloseDoc:!0});case"disconnecting":case"disconnected":return;default:return void ft()}}catch(e){ft(),J.warn("Error caught in EditApplication.quitHandler.connectionGateKeeper:",e)}}var i=null;try{w.log("EditApplication.quitHandler - reason",e),v.DEBUG&&mt.debugTypeError.test("sync-quithandler"),"reload"===e?(ft(),i=$.when()):i=gt(e)}catch(e){i=$.when(),J.warn("Error caught in EditApplication.quitHandler:",e)}return i=i.then(n,n),i=i.then(t,t)}),this.waitForImportStart(function(){m.logState("import","app/loading","pending")}),this.once("docs:state:preview",function(){m.logState("import","app/preview","pending")}),this.waitForImport(function(){m.logState("import","app/preview","resolved"),m.logState("import","app/loading","resolved")}),this.waitForImportSuccess(function(){Ht&&Qn.start()}),this.registerDestructor(function(){Qn.destroy(),Bn.destroy(),r=s=mt=Nt=Rt=null,Ct=Tt=wt=Fn=null,Lt=Gt=null,xt=kt=Pt=null,Bt=Mt=null,Jt=En=On=_n=null,In=Qn=null,Bn=Mn=null})})});